Dart TeamSpeak Library
==============

This is a small library which allows Dart-Applications to keep track of users
that are currently connected to a TeamSpeak3-server. The library connects
using the ServerQuery protocol as documented 
[here](http://media.teamspeak.com/ts3_literature/TeamSpeak%203%20Server%20Query%20Manual.pdf)
and uses the [Dart-TeamSpeak-Library](https://github.com/gwTumm/dart-teamspeak) for
this. The UserTracker provides a stream of events of the following types:

* UserEnteredServerEvent
* UserLeftServerEvent
* UserStartedTalkingEvent
* UserStoppedTalkingEvent
* UserTalkedEvent
* UserEnteredChannelEvent
* UserLeftChannelEvent

The talking detection is **not** reliable since it monitors the bandwidth usage
of the clients to detect whether users are talking or not. So e. g. if you are uploading
a file to the TeamSpeak-server using the client, it is also considered talking.

Please note that this library can only be used for tracking clients using an
unthrottled connection since it needs a bit of bandwidth.
Unthrottled connections should only established to TeamSpeak-Servers that whitelisted 
your public ip.

Usage
--------------

Just create a UserTracker class after creating your TeamSpeak-serverquery-client. 
See test/dumpevents.dart for an example usage. 