part of TeamSpeak_UserTrack;

class TimedUserEvent extends UserEvent {
  final DateTime time;
  
  TimedUserEvent(user) 
    : time = new DateTime.now(), super(user);
}

class UserEnteredServerEvent extends TimedUserEvent {
  UserEnteredServerEvent(user) : super(user);
}

class UserEnteredChannelEvent extends TimedUserEvent {
  final Channel channel;
  
  UserEnteredChannelEvent(user, this.channel) : super(user);
}

class UserLeftChannelEvent extends TimedUserEvent {
  final Channel channel;
  final DateTime joinedTime;
  final Duration onlineTime;
  
  UserLeftChannelEvent(user, this.channel, this.joinedTime, this.onlineTime) : super(user);
}

class UserLeftServerEvent extends TimedUserEvent {
  final DateTime joinedTime;
  final Duration onlineTime;
  
  UserLeftServerEvent(user, this.joinedTime, this.onlineTime) : super(user);
}

class UserStartedTalkingEvent extends TimedUserEvent {
  UserStartedTalkingEvent(user) : super(user);
}

class UserStoppedTalkingEvent extends TimedUserEvent {
  final DateTime startedTalkTime;
  final Duration talkTime;
  
  UserStoppedTalkingEvent(user, this.startedTalkTime, this.talkTime) : super(user);
}

class UserTalkedEvent extends UserStoppedTalkingEvent {
  UserTalkedEvent(user, startedTalkTime, talkTime)
    : super(user, startedTalkTime, talkTime);
}